import numpy as np
import matplotlib.pyplot as plt
from matplotlib.animation import FuncAnimation

#samme kommoentar som oving 5 og 6
fig, ax = plt.subplots()
ax.set_xlabel(r'$x$')
ax.set_xlabel(r'$y$')

xdata, ydata = [], []
ln, = plt.plot([], [], animated=True,label=r'$u\, (x,t)$') # skriv inn 'ro' som tredje argument hvis du vil ha tilbake punkter i stedet for linjer.

def init():
    ax.set_xlim(0, 2)
    ax.set_ylim(-.5, 1.5)
    return ln,

def update(frame):
    xdata=np.linspace(0, 2, 128)
    ydata=np.exp(-np.pi**2*frame/4.0)*np.sin(np.pi*xdata/2)
    ln.set_data(xdata, ydata)
    return ln,

# Man kan endre hastigheten ved aa endre paa interval-parameteren
ani = FuncAnimation(fig, update, frames=np.linspace(0, 2, 128),interval=30,
                    init_func=init, blit=True)
plt.legend()
plt.show()
