from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
from matplotlib import cm
from matplotlib.ticker import LinearLocator, FormatStrFormatter
import numpy as np


#x- og y-aksen
x = np.linspace(0, 2, 128)
t = np.linspace(0, 2, 128)

#ytreprodukt av x- og y-aksen. surf trenger dette for aa funke.
X,T=np.meshgrid(x,t)

#funksjonsverdiene
u=np.multiply(np.exp(-np.pi**2*T/4.0),np.sin(np.pi*X/2))

#lage plot. et par av disse kommandoene vet jeg ikke hva gjor, men jeg fant dem paa nettet
fig = plt.figure()

ax = fig.gca(projection='3d')
surf = ax.plot_surface(X, T, u, cmap=cm.coolwarm,
                       linewidth=0, antialiased=False)

#korrekt utsnitt av xy-planet
plt.axis([0,2,0,2])

# navn paa aksene
plt.xlabel(r'$x$')
plt.ylabel(r'$t$')
ax.set_zlabel(r'$u(x,t)$')

#vise plot
plt.show()
