import numpy as np

# Her har vi brukt at tredjeroten til 7 er en løsning av likningen x^3-7=0.
# Dersom vi anvender newtons metode på denne likningen får vi fikspunktiterasjonen vi løser for i koden under
# Ellers er logikken den samme som i 08_2

def g(x):
    return (2*x**3+7.0)/(3*x**2)

def newton(x,tol):
    d = 1 # differanse mellom ny og forrige x
    n = 0
    while d>tol:
        xp = x
        x = g(x)
        d = np.abs(x-xp)
        n = n + 1
    return x,n

if __name__ == "__main__":
    tol = 10.0**-16
    x0 = 1.9 # Vi vet at 2^3=8, så roten bør ligge rundt denne verdien. 1.9 er derfor en fornuftig initialverdi.
    x,n = newton(x0,tol)
    print("Løsning: x =",x)
    print("x^3 =",x**3.0)
    print("Feil:",x-7.0**(1.0/3))
    print("Antall iterasjoner:", n)