import numpy as np

# funksjonen vi skal integrere
def f(x):
    return np.exp(x)

# implementasjon av trapesregelen
def composite_trapezoid(a,b,f,n):
    h = (b-a)/n
    sum = h/2*(f(a)+f(b))
    for i in range(1,n):
        sum = sum + h*f(a+i*h)
    return sum

if __name__ == "__main__":
    tol = 10.0**-10
    a = -1.0
    b = 1.0
    d = 1 # differansen mellom estimatene for n paneler og n+1 paneler.
    new = old = composite_trapezoid(a,b,f,1) # oppdatert og forrige estimat, så vi kan regne ut feilen.
    n = 2
    while d>tol: #dersom det å velge større n ikke gir noe særlig bedre estimat enn toleransen, er vi ganske nær eksakt løsning
        new = composite_trapezoid(a,b,f,n)
        d = np.abs(new-old)
        old = new
        n = n + 1
    I = np.exp(1.0)-np.exp(-1.0)
    print("Resultat:",new)
    print("Eksakt svar:",I)
    print("Feil i svaret:",I-new)
    print("n =",n)