import numpy as np
import matplotlib.pyplot as plt

# eksakt lsning
def y(x):
    return 2.0/(2.0-x**2)

# vi skriver om likningen saa vi faar den paa formen y'=f(x,y)
def f(x,y):
    return x*np.power(y,2)

# regner ut euler-approksimasjonen i x=1 med steglengde h
def euler(x,y,n):
    h = 1.0/n
    for i in range(n):
        y = y + h*f(x,y)
        x = x+h
    return y

def rk4(x,y,n):
    h = 1.0/n
    for i in range(n):
        k1 = f(x,y)
        k2 = f(x+h/2.0,y+k1*h/2.0)
        k3 = f(x + h / 2.0, y + k2 * h / 2.0)
        k4 = f(x+h,y+h*k3)
        y = y + h/6.0*(k1+2*k2+2*k3+k4)
        x = x+h
    return y

# I koden under har vi valgt aa oke antall steg med en faktor paa 10 hver gang. Grunnen til at dette er aa foretrekke
# framfor aa oke antall steg med en av gangen er at euler konvergerer veldig tregt, saa aa ke antall steg med en tar
# veldig lang tid. Her faar vi ikke nyaktig svar paa hvor mange steg vi trenger, men dette gir oss ikke saa mye mer
# informasjon vi faar ved aa se paa narmeste tierpotens uansett.

if __name__ == "__main__":
    x0 = 0
    y0 = 1
    err = 1
    tol = 10.0**-5
    n_e = 0.1
    yn = 0
    while err>tol:
        n_e = int(n_e * 10)
        yn = euler(x0,y0,n_e)
        err = np.abs(y(1)-yn)
    h_e = 1.0/n_e
    n_r = 0.1
    err = 1
    while err>tol:
        n_r = int(n_r * 10)
        yn = rk4(x0,y0,n_r)
        err = np.abs(y(1)-yn)
    h_r = 1.0/n_r
    print("Step-size euler:",h_e)
    print("Step-size rk4:",h_r)
