import numpy as np
import matplotlib.pyplot as plt

# eksakt losning
def y_e(x):
    return np.exp(-30*x)

def f(x,y):
    return -30*y

def explicit_euler(x,y,n):
    h = 1.0/n
    for i in range(n):
        y = y + h*f(x,y)
        # x = x+h
    return y

def implicit_euler(x,y,n):
    h = 1.0/n
    for i in range(n):
        y = y/(1+30*h)
        # x = x+h
    return y

if __name__ == "__main__":
    x0 = 0
    y0 = 1
    err_e = np.zeros(3)
    err_i = np.zeros(3)
    for i in range(3):
        n = 10**i
        y = explicit_euler(x0,y0,n)
        err_e[i] = np.abs(y-y_e(1))
    for i in range(3):
        n = 10**i
        y = implicit_euler(x0,y0,n)
        err_i[i] = np.abs(y-y_e(1))

    # plotter feilene mot h
    fig = plt.figure()
    ax = fig.add_subplot(1,1,1)
    ax.plot([1,0.1,0.01],err_e,label=r'Explicit')
    ax.plot([1,0.1,0.01],err_i,label=r'Implicit')
    ax.set_xscale('log')
    ax.set_yscale('log')
    ax.set_xlabel(r'$h$')
    ax.set_ylabel(r'$Error$')
    ax.legend()
    plt.show()
