#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import numpy as np
import matplotlib.pyplot as plt

def f(y):
    return y**2-y**3

# med implisitt trap

def newton(z,h): # z er y_i og blir startgjetningen vaar for forste iterasjon hver gang denne kalles.
    tol = 10.0**-6
    err = 1.0
    y = x =  z
    while err>tol:
        y = y - ( z-y+0.5*h* ( z**2-z**3+y**2-y**3 ) )/(-1.0+0.5*h*(2*y-3*y**2) )
        err = np.abs(y-x)
        x = y  # x er forrige verdi av y_i i iterasjonen, brukes for aa sjekke feilen
    return y


# denne er ogsaa kjent som den eksplisitte trapesmetoden
def heun(t0,y0,n):
    h = 25/n
    y = np.zeros(n)
    t = np.zeros(n)
    y[0] = y0
    t[0] = t0
    for i in range(n-1):
        y[i+1] = y[i]+0.5*h*(f(y[i])+f( y[i] + h * f(y[i]) ) )
        t[i+1] = t[i]+h
    return t,y


# dette er den vanlige implisitte trapesmetoden
def trapezoid(t0,y0,n):
    h = 25/n
    y = np.zeros(n)
    t = np.zeros(n)
    y[0] = y0
    t[0] = t0
    for i in range(n-1):
        y[i+1] = newton(y[i],h)
        t[i+1] = t[i]+h
    return t,y

def plotfigure(t,y,lab):
    fig = plt.figure()
    ax = fig.add_subplot(1,1,1)
    ax.plot(t,y,label=lab)
    ax.set_xlabel(r'$t$')
    ax.set_ylabel(r'$y$')
    ax.legend()
    return ax

if __name__ == "__main__":
    t0 = 0
    y0 = 0.01
    n = 100
    t,y = trapezoid(t0,y0,n)
    plotfigure(t,y,r'Heun')
    t,y = heun(t0,y0,n)
    plotfigure(t,y,r'Trapezoid')
    plt.show()
