import numpy as np
import matplotlib.pyplot as plt
from matplotlib.animation import FuncAnimation

#her setter vi opp gitter langs x- og t-aksene
n=10
h=1.0/n
m=1000
k=1.0/m
r=k/h**2

x=np.linspace(0,1,n)
t=np.linspace(0,3,m)

#det er vanlig aa lagre losningen som en nullvektor forst, slik at den faar rett str
u=np.zeros((m+1,n))

#initialverdier
for i in range(n):
    u[0,i]=np.sin(np.pi*x[i])

#her beregner vi losningen
for i in range(m):
    for j in range(n-2):
        u[i+1,j+1]=u[i,j+1]+r*(u[i,j+2]-2*u[i,j+1]+u[i,j])
    # plt.plot(x,u[i])


#samme kommoentar som oving 5 og 6
fig, ax = plt.subplots()
ax.set_xlabel(r'$x$')
ax.set_ylabel(r'$y$')

xdata, ydata = [], []
ln, = plt.plot([], [], animated=True,label=r'$u\, (x,t)$') # skriv inn 'ro' som tredje argument hvis du vil ha tilbake punkter i stedet for linjer.

def init():
    ax.set_xlim(0, 1)
    ax.set_ylim(0, 1.1)
    return ln,

def update(frame):
    xdata=np.linspace(0, 1, n)
    ydata=u[frame]
    ln.set_data(xdata, ydata)
    return ln,

# Man kan endre hastigheten ved å endre på interval-parameteren
ani = FuncAnimation(fig, update, frames=np.linspace(0, m, m+1, dtype=np.int32),interval=30,
                    init_func=init, blit=True)
plt.legend()
plt.show()